#include "testlib.h"
#include <deque>
#include <set>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using info = tuple<int, int, int>;

int n, m, r, c;
vector<info> moves;

vector<pii> D{
        {-1, 0},
        {1,  0},
        {0,  -1},
        {0,  1}
};

int check(InStream &in) {
    int i = r, j = c;
    deque<pii> q{{i, j}};
    int const mx = n * m + 1;
    vector<vector<int>> dist(n, vector<int>(m, mx));
    dist[i][j] = 0;

    set<pii> trapped;
    if (n == 1 && m == 1) trapped.insert({0, 0});

    vector<vector<int>> del(n, vector<int>(m, 0));
    ll total = 0;
    int oddity = (i + j) % 2;

    int result = in.readInt(1, n * m, "answer");
    for (int s = 0; s < result; s++) {
        auto [k, ri, ci] = moves[s];
        total += k;
        oddity ^= k % 2;

        while (!q.empty()) {
            auto [x, y] = q.front();
            if (dist[x][y] == total) break;
            q.pop_front();

            for (auto [dx, dy] : D) {
                int tx = x + dx, ty = y + dy;
                if (tx < 0 || tx >= n || ty < 0 || ty >= m) continue;
                if (del[tx][ty]) continue;
                if (dist[tx][ty] > dist[x][y] + 1) {
                    dist[tx][ty] = dist[x][y] + 1;
                    q.emplace_back(tx, ty);
                }
            }
        }

        del[ri][ci] = 1;
        for (auto [dx, dy] : D) {
            int tx = ri + dx, ty = ci + dy;
            if (tx < 0 || tx >= n || ty < 0 || ty >= m) continue;
            if (oddity != (tx + ty) % 2) continue;
            if (dist[tx][ty] == mx) continue;

            bool cornered = true;
            for (auto [dx2, dy2] : D) {
                int nx = tx + dx2, ny = ty + dy2;
                if (nx < 0 || nx >= n || ny < 0 || ny >= m) continue;
                cornered &= del[nx][ny];
            }
            if (cornered) trapped.insert({tx, ty});
        }
    }

    auto [_, fr, fc] = moves[result - 1];
    if (dist[fr][fc] == mx) return -1;
    if (trapped.count({fr, fc}) || oddity == (fr + fc) % 2) return result;
    return -2;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    n = inf.readInt(), m = inf.readInt(), r = inf.readInt() - 1, c = inf.readInt() - 1;
    int pts = inf.readInt();
    for (int i = 0; i < n * m; i++) {
        int k = inf.readInt(), ri = inf.readInt() - 1, ci = inf.readInt() - 1;
        moves.emplace_back(k, ri, ci);
    }

    int ja = check(ans), pa = check(ouf);
    if (ja < 0) quitf(_fail, "jury has wrong answer");
    if (pa < 0) quitf(_wa, "participant has wrong answer");
    if (pa < ja) quitf(_fail, "jury's solution is not optimal");

    int result = (pts * ja) / pa;
    quitp(result, to_string(result));

}