#include "testlib.h"
#include <deque>

using namespace std;

#define default(type, name, value) has_opt(name) ? opt<type>(name) : value
#define all(c) c.begin(), c.end()

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int n = opt<int>("n"), m = opt<int>("m");
    int k = default(int, "k", 1000'000'000);
    int pts = opt<int>("pts");
    bool rev = default(bool, "reverse", false);
    bool swt = default(bool, "switch", true);

    bool g1 = has_opt("k1_nm") && opt<bool>("k1_nm");
    bool g8 = has_opt("rc_1") && opt<bool>("rc_1");

    vector<deque<pair<int, int>>> group(2);
    for (int x = 0; x < n; x++) {
        for (int y = m - 1; y > -1; y--) {
            group[(x + y) % 2].emplace_back(x, y);
        }
    }

    int r = rnd.next(1, n), c = rnd.next(1, m);
    if (g8) r = 1, c = 1;
    auto cmp = [&](pair<int, int> const &p1, pair<int, int> const &p2) {
        return abs(p1.first - r) + abs(p1.second - c) > abs(p2.first - r) + abs(p2.second - c);
    };
    sort(all(group[0]), cmp);
    sort(all(group[1]), cmp);
    if (rev) {
        reverse(all(group[0]));
        reverse(all(group[1]));
    }

    println(n, m, r, c);
    println(pts);

    int oddity = (r + c) % 2;
    int d = 1;
    if (g1) d = n + m;

    for (int i = 0; i < n * m; i++) {
        d = min(d, k);
        int g = (oddity + d + swt) % 2;
        if (group[g].empty()) {
            g ^= 1;
        }

        auto [x, y] = group[g].front();
        group[g].pop_front();
        println(d, x + 1, y + 1);
        d = 2;
    }

}