#include "testlib.h"

using namespace std;

#define default(type, name, value) has_opt(name) ? opt<type>(name) : value
#define all(c) c.begin(), c.end()

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int n = opt<int>("n"), m = opt<int>("m");
    int k = default(int, "k", 1000'000'000);
    int pts = opt<int>("pts");

    bool g1 = has_opt("k1_nm") && opt<bool>("k1_nm");
    bool g8 = has_opt("rc_1") && opt<bool>("rc_1");
    bool strategy = default(bool, "strategy", true);

    vector<pair<int, int>> cells;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cells.emplace_back(i + 1, j + 1);
        }
    }
    shuffle(all(cells));

    int r = rnd.next(1, n), c = rnd.next(1, m);
    if (g8) r = 1, c = 1;
    println(n, m, r, c);
    println(pts);

    int oddity = (r + c) % 2;
    auto move = [&](int i, int j) {
        if (!strategy) return rnd.next(1, k);
        int d = (i + j - oddity) % k;
        d += 1;
        return d + 2 * rnd.next(0, (k - d) / 2);
    };

    if (g1) {
        println(n + m, cells.back().first, cells.back().second);
        cells.pop_back();
    }
    for (auto [i, j] : cells) {
        int d = move(i, j);
        println(d, i, j);
        oddity ^= d & 1;
    }

}