#include "testlib.h"

using namespace std;

#define default(type, name, value) has_opt(name) ? opt<type>(name) : value
#define all(c) c.begin(), c.end()

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int n = opt<int>("n"), m = opt<int>("m");
    int k = default(int, "k", 1000'000'000);
    int pts = opt<int>("pts");

    bool g1 = has_opt("k1_nm") && opt<bool>("k1_nm");
    bool g8 = has_opt("rc_1") && opt<bool>("rc_1");
    bool strategy = default(bool, "strategy", true);

    vector<pair<int, int>> cells;
    int r1 = 1, c1 = 1, r2 = n, c2 = m;
    while (true) {
        if (rnd.next(2)) {
            int j = c1;
            while (true) {
                cells.emplace_back(r1, j);
                if (j == c2) break;
                if (c2 > c1) j++; else j--;
            }
            if (r1 == r2) break;
            if (r2 > r1) r1++; else r1--;
            swap(c1, c2);
        } else {
            int i = r1;
            while (true) {
                cells.emplace_back(i, c1);
                if (i == r2) break;
                if (r2 > r1) i++; else i--;
            }
            if (c1 == c2) break;
            if (c2 > c1) c1++; else c1--;
            swap(r1, r2);
        }
    }

    int r = rnd.next(1, n), c = rnd.next(1, m);
    if (g8) r = 1, c = 1;
    println(n, m, r, c);
    println(pts);

    int oddity = (r + c) % 2;
    auto move = [&](int i, int j) {
        if (!strategy) return rnd.next(1, k);
        int d = (i + j - oddity) % k;
        d += 1;
        return d + 2 * rnd.next(0, (k - d) / 2);
    };

    if (g1) {
        println(n + m, cells[0].first, cells[0].second);
    }
    for (int i = g1; i < cells.size(); i++) {
        auto [ii, jj] = cells[i];
        int d = move(ii, jj);
        println(d, ii, jj);
        oddity ^= d & 1;
    }

}