#include "testlib.h"
#include <deque>

using namespace std;

#define default(type, name, value) has_opt(name) ? opt<type>(name) : value
#define all(c) c.begin(), c.end()

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);

    int n = opt<int>("n"), m = opt<int>("m");
    int k = default(int, "k", 1000'000'000);
    int pts = opt<int>("pts");

    bool g1 = has_opt("k1_nm") && opt<bool>("k1_nm");
    bool g8 = has_opt("rc_1") && opt<bool>("rc_1");
    bool reverse = default(bool, "reverse", true);

    vector<deque<pair<int, int>>> group(2);
    for (int x = 0; x < n; x++) {
        if (x % 2 && !reverse) {
            for (int y = m - 1; y > -1; y--) {
                group[(x + y) % 2].emplace_back(x, y);
            }
        } else {
            for (int y = 0; y < m; y++) {
                group[(x + y) % 2].emplace_back(x, y);
            }
        }
    }

    int r = rnd.next(1, n), c = rnd.next(1, m);
    if (g8) r = 1, c = 1;
    println(n, m, r, c);
    println(pts);

    int oddity = (r + c) % 2;
    int d = 1;
    if (g1) d = n + m;

    for (int i = 0; i < n * m; i++) {
        d = min(d, k);
        oddity ^= d & 1;
        if ((!g1 || i > 0) && group[oddity].size() > group[oddity ^ 1].size()) {
            d++;
            oddity ^= 1;
        }

        auto [x, y] = group[oddity ^ 1].front();
        group[oddity ^ 1].pop_front();
        println(d, x + 1, y + 1);
        d = 1;
    }

}