#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const NM = 1000;
    int const K = 1000'000'000;

    int __g = validator.group().empty() ? 0 : stoi(validator.group());

    int n = inf.readInt(1, NM, "n");
    inf.readSpace();
    int m = inf.readInt(1, NM, "m");
    inf.readSpace();
    int r = inf.readInt(1, n, "r");
    inf.readSpace();
    int c = inf.readInt(1, m, "c");
    inf.readEoln();

    if (__g == 6) {
        ensuref(n == 1, "group 6 requires n = 1 but n = %d", n);
    } else if (__g == 7) {
        ensuref(n <= 40, "group 7 requires n <= 40 but n = %d", n);
        ensuref(m <= 40, "group 7 requires m <= 40 but m = %d", m);
    }

    if (__g == 8) {
        ensuref(r == 1, "group 8 requires r = 1 but r = %d", r);
        ensuref(c == 1, "group 8 requires c = 1 but c = %d", c);
    }

    inf.readInt(0, 100, "pts");
    inf.readEoln();

    vector<vector<int>> del(n, vector<int>(m, 0));
    int pi = 0, pj = 0;
    for (int t = 0; t < n * m; t++) {
        int k = inf.readInt(1, K, format("k_%d", t + 1));
        inf.readSpace();
        int i = inf.readInt(1, n, format("i_%d", t + 1)) - 1;
        inf.readSpace();
        int j = inf.readInt(1, m, format("j_%d", t + 1)) - 1;
        inf.readEoln();

        ensuref(!del[i][j], "cell (%d, %d) is deleted twice", i + 1, j + 1);
        del[i][j] = 1;

        if (__g == 1 && t == 0) {
            ensuref(k == n + m, "group 1 requires k1 = n + m = %d but k1 = %d", n + m, k);
        } else if (__g == 2) {
            ensuref(k == 1, "group 2 requires k = 1 but k%d = %d", t + 1, k);
        } else if (__g == 5) {
            ensuref(k <= 2, "group 5 requires k <= 2 but k%d = %d", t + 1, k);
        }

        if (__g == 4 && i > 0) {
            ensuref(abs(i - pi) + abs(j - pj) == 1,
                    "group 4 requires cells to be neighbors but (%d, %d) and (%d, %d) are not",
                    pi + 1, pj + 1, i + 1, j + 1);
        }
        pi = i;
        pj = j;
    }

    inf.readEof();

}