/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

vector<pii> D{
        {-1, 0},
        {1,  0},
        {0,  -1},
        {0,  1}
};

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, m, i, j, pts)
    i--, j--;

    deque<pii> q{{i, j}};
    int const mx = n * m + 1;
    vector<vector<int>> dist(n, vector<int>(m, mx));
    dist[i][j] = 0;

    set<pii> trapped;
    if (n == 1 && m == 1) trapped.insert({0, 0});

    vector<vector<int>> del(n, vector<int>(m, 0));
    ll total = 0;
    int oddity = (i + j) % 2, steps = 0;

    while (true) {
        steps++;
        in(int, k, r, c)
        r--, c--;

        assert(!del[r][c]);
        total += k;
        oddity ^= k % 2;

        while (!q.empty()) {
            auto [x, y] = q.front();
            if (dist[x][y] == total) break;
            q.pop_front();

            for (auto [dx, dy] : D) {
                int tx = x + dx, ty = y + dy;
                if (tx < 0 || tx >= n || ty < 0 || ty >= m) continue;
                if (del[tx][ty]) continue;
                if (dist[tx][ty] > dist[x][y] + 1) {
                    dist[tx][ty] = dist[x][y] + 1;
                    q.emplace_back(tx, ty);
                }
            }
        }

        if (dist[r][c] != mx && dist[r][c] <= total) {
            if (oddity == (r + c) % 2 || trapped.count({r, c})) {
                cout << steps << '\n';
                return 0;
            }
        }

        del[r][c] = 1;
        for (auto [dx, dy] : D) {
            int tx = r + dx, ty = c + dy;
            if (tx < 0 || tx >= n || ty < 0 || ty >= m) continue;
            if (oddity != (tx + ty) % 2) continue;
            if (dist[tx][ty] == mx) continue;

            bool cornered = true;
            for (auto [dx2, dy2] : D) {
                int nx = tx + dx2, ny = ty + dy2;
                if (nx < 0 || nx >= n || ny < 0 || ny >= m) continue;
                cornered &= del[nx][ny];
            }
            if (cornered) trapped.insert({tx, ty});
        }
    }

}