#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const Q = 100'000;
    long long const N = 1000'000'000;
    long long const K = 1000'000'000;
    long long const N5 = 100'000;

    // @formatter:off
    vector<int> const       Qg{Q,  Q, Q,  1,  Q,  Q, 500, Q};
    vector<long long> const Ng{N, N5, N, N5, N5, N5,   N, N};
    // @formatter:on

    int __g = validator.group().empty() ? 0 : stoi(validator.group());

    int q = inf.readInt(1, Qg[__g], "q");
    inf.readEoln();

    long long k0 = 0;
    for (int i = 0; i < q; i++) {
        long long n = inf.readLong(1LL, Ng[__g], format("n_%d", i + 1));
        inf.readSpace();
        long long k = inf.readLong(1LL, K, format("k_%d", i + 1));
        inf.readEoln();

        if (__g == 1) {
            ensuref(k == 2, "group 1 requires k = 2 but k_%d = %lld", i + 1, k);
        } else if (__g == 2) {
            ensuref(n <= k, "group 2 requires n <= k but n_%d = %lld and k_%d = %lld", i + 1, n, i + 1, k);
        } else if (__g == 4) {
            ensuref(k == 10, "group 4 requires k = 10 but k_%d = %lld", i + 1, k);
        } else if (__g == 5) {
            if (i == 0) {
                k0 = k;
            } else {
                ensuref(k == k0, "group 5 requires all k to be equal but k_1 = %lld and k_%d = %lld", k0, i + 1, k);
            }
        } else if (__g == 6) {
            ensuref(k >= 20, "group 6 requires k >= 20 but k_%d = %lld", i + 1, k);
        }
    }

    inf.readEof();

}