#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

#define int long long

using namespace std;


const int MAXN = 1e6;

// k = 2
void solve1(int n, int k) {
    cout << n << "\n";
}


// n <= k
void solve2(int n, int k) {
    if (n == 1) {
        cout << n << "\n";
    }
    else {
        cout << k << "\n";
    }
}


// n <= 10^6, q = 1
void solve3(int n, int k) {
    for (int i = n; ; i++) {
        int x = i;
        int ok = 1;

        while (x > 0) {
            if (x % k > 1) {
                ok = 0;
                break;
            }
            x /= k;
        }

        if (ok) {
            cout << i << "\n";
            break;
        }
    }
}


vector<int> good_numbers;

void precalc4(int k) {

    for (int i = 1; i <= MAXN * 4; i++) {
        int num = 0;
        int pw = 1;
        int x = i;
        bool ok = true;
        while (x > 0) {
            if (x % k > 1) {
                ok = false;
                break;
            }
            num += (x % k) * pw;
            pw *= k;
            x /= k;
        }
        if (ok) {
            good_numbers.push_back(num);
        }
    }
}

// n <= 10^6, q <= 10^5, k - const
void solve4(int n, int k) {
    int l = -1;
    int r = good_numbers.size() - 1;

    while (r - l > 1) {
        int m = (r + l) / 2;
        if (n > good_numbers[m]) l = m;
        else r = m;
    }
    cout << good_numbers[r] << "\n";
}


// 10 <= k <= 10^18, n <= 10^18, q = 500
void solve5(int n, int k) {
    int mask_len = (int)(ceil(log(n) / log(k)) + 1);

    vector<int> pows(mask_len + 1);
    pows[0] = 1;
    for (int i = 1; i < mask_len + 1; i++)
        pows[i] = pows[i - 1] * k;

    for (int i = 1; i < (1 << (mask_len + 1)); i++) {
        int num = 0;
        for (int pos = 0; pos <= mask_len + 1; pos++) {
            num += (i >> pos & 1) * pows[pos];
        }
        if (num >= n) {
            cout << num << "\n";
            break;
        }
    }
}

void solve_all(int n, int k) {
    vector<int> kth;

    int nn = n;
    int last = -1;
    while (nn > 0) {
        kth.push_back(nn % k);
        if (kth.back() > 1) last = kth.size() - 1;
        nn /= k;
    }

    if (last < 0) {
        cout << n << "\n";
        return;
    }

    int zero = -1;
    int pw_k = 1;
    for (int i = 0; i < kth.size(); i++) {
        if (!kth[i] && i > last && zero < 0)  {
            zero = i;
            break;
        }
        pw_k *= k;
    }

    if (zero >= 0) kth[zero] = 1;
    else kth.push_back(1), zero = kth.size() - 1;

    int ans = 0;

    for (int i = zero; i < kth.size(); i++) {
        ans += pw_k * kth[i], pw_k *= k;
    }
    cout << ans << "\n";
}

int32_t main() {
    int q; cin >> q;

    while (q--) {
        int n, k; cin >> n >> k;
        //solve1(n, k);
        //solve2(n, k);
        //solve3(n, k);
        solve_all(n, k);
    }

    return 0;
}
