#include <iostream>
#include <array>
#include <exception>
#include "testlib.h"
#include <string>

using namespace std;

const array<int, 8> MAX_SUM_N = {120, 120, 120, 120, 120, 120, 120, 120 };
const array<int, 8> MAX_T = { 120, 120, 120, 120, 120, 120, 120, 120 };
const array<int, 8> MAX_N = { 40, 20, 40, 40, 30, 40, 40, 40 };
const array<int, 8> MAX_K = { 30, 30, 0, 3, 30, 30, 2, 30 };
const array<int, 8> MIN_K = { 0, 0, 0, 0, 0, 0, 2, 0 };

//const array<int, 9> MAX_MAST = { 1'000'000'000, 1'000'000'000 , 1'000'000'000 , 1'000'000'000 , 1'000'000'000 , 1'000'000'000 , 1'000'000'000 , 1'000'000'000 , 1'000'000'000 };
//const array<int, 9> MIN_MAST = { -1'000'000'000, -1'000'000'000, -1'000'000'000 , -1'000'000'000 , -1'000'000'000 , -1'000'000'000 , -1'000'000'000 , 1, -1'000'000'000 };
//const array<int, 9> MAX_N = { 2'000'00, 500, 3000, 10000, 2'000'00, 2'000'00, 5'000'0, 2'000'00, 2'000'00 };
//const array<int, 9> MAX_K = { 1'000'000'000, 1'000'000'000 , 1'000'000'000 , 1'000'000'000 , 1'000'000'000 , 0 , 1'000'000'000 , 1'000'000'000 , 1'000'000'000 };
//const array<int, 9> MIN_K = { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int read_test_case(int group) {
    int n = inf.readInt(1, MAX_N[group], "N");
    inf.readSpace();
    int m = inf.readInt(0, n * (n - 1) / 2, "M");
    inf.readSpace();
    int k = inf.readInt(MIN_K[group], MAX_K[group], "K");
    inf.readEoln();
    vector<int> a; a.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        a[i] = inf.readInt(0, (1ll << k) - 1, "a[i], i is " + to_string(i));
        if (i + 1 != n) inf.readSpace();
    }
    inf.readEoln();
    vector<vector<int>> friends; friends.assign(n, vector<int>(n, 0));
    for (int pps = 0; pps < m; ++pps) {
        int f = 0, s = 0;
        f = inf.readInt(1, n, "f[" + to_string(pps) + "]");
        inf.readSpace(); 
        s = inf.readInt(1, n, "s[" + to_string(pps) + "]");
        f--; s--;
        inf.readEoln();
        ensuref(f != s, "The friends should be different people!");
        string para = "There should be no matching friend pairs!" + to_string(f) + to_string(s) + ".";
        ensuref(friends[f][s] == 0, para.data());
        ensuref(friends[s][f] == 0, para.data());
        friends[f][s] = friends[s][f] = 1;
    }
    if (group == 5) {
        for (int j = 1; j < n; ++j) {
            string frm = "In the fifth group al numbers except a1 should be 0, breaker - a[" + to_string(j) + +"], equal to " + to_string(a[j]);
            ensuref(a[j] == 0, frm.data());
        }
    }
    if (group == 6) {
        ensuref(n % 2 == 0, "n should be even");
        for (int i = 0; i < n / 2; ++i) {
            ensuref(a[i] == 1, "First half should be all 1");
        }
        for (int i = n / 2; i < n; ++i) {
            ensuref(a[i] == 2, "Second half should be 2");
        }
    }
    return n;
}


int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = 0;
    try {
        group = stoi(validator.group());
    }
    catch (exception& e1) {
        group = 0;
    }
    int T = inf.readInt(1, MAX_T[group], "T");
    int max_sum_n = MAX_SUM_N[group];
    inf.readEoln();
    int sum = 0;
    int sum2 = 0;
    for (int k = 0; k < T; ++k) {
        setTestCase(k + 1);
        auto p = read_test_case(group);
        sum += p;
        ensuref(sum <= max_sum_n, "The sum of sizes has exceeded the limit!");
    }
    inf.readEof();
}
