#include "testlib.h"

#define fori(n) for (int i = 0; i < (n); ++i)
#define ll long long
#define MAX_SUM ((ll)1e18)

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = has_opt("n") ? opt<int>("n") : (int)2e5;
    int q = has_opt("q") ? opt<int>("q") : (int)2e5;
    int sorted = has_opt("sorted") ? opt<int>("sorted") : 0; // sorted by p
    int max_p = has_opt("p") ? opt<int>("p") : (int)1e9;
    int max_h = has_opt("h") ? opt<int>("h") : (int)1e9;

    println(n, q);

    vector<pair<int, int>> v(n);

    ll sum = 0;
    fori(n) {
        ll stay = MAX_SUM - sum;
        ll can_use = stay - (n - i - 1) * 100000ll;

        ll p = rnd.next(1ll, min<ll>({(ll)1e9, can_use / 100 + 1, max_p}));
        ll h = rnd.next(1ll, min<ll>({(ll)1e9, can_use / p, max_h}));
        v[i] = {p, h};

        sum += p * h;
    }

    if (sorted) sort(v.begin(), v.end());

    fori(n) {
        println(v[i].first, v[i].second);
    }

    fori(q) {
        int qq = rnd.next(1, max_p);
        println(qq);
    }
}