#include "testlib.h"

#define fori(n) for (int i = 0; i < (n); ++i)

using namespace std;

int main(int argc, char *argv[]) {
    
    registerValidation(argc, argv);
    
    int const N = 200'000;
    int const Q = 200'000;
    int const P = 1000'000'000;
    int const H = 1000'000'000;
    int const T = 1000'000'000;
    
    // @formatter:off
    vector<int> const Ng{N,  15, 500, 2000, 5000, N, N, N,       N, N};
    vector<int> const Qg{Q, 100, 500, 2000, 5000, Q, Q, Q,       Q, Q};
    vector<int> const Pg{P, 100,   P,    P,    P, P, P, P, 100'000, P};
    // @formatter:on

    int __g = validator.group().empty() ? 0 : stoi(validator.group());

    int n = inf.readInt(1, Ng[__g], "n");
    inf.readSpace();
    int q = inf.readInt(1, Qg[__g], "q");
    inf.readEoln();

    unsigned long long temp = 0;
    long long p_prev = 0, h_1 = 0;
    set<int> p_all;
    fori(n) {
        long long p, h;
        p = inf.readLong(1ll, Pg[__g], format("p_%d", i + 1));
        inf.readSpace();
        h = inf.readLong(1ll, H, format("h_%d", i + 1));
        inf.readEoln();
        temp += p * h;
        
        ensuref(temp <= (long long)1e18, "sum of p_i * h_i should be less than 10^18 but is not");
        
        if (__g == 5) {
            ensuref(p >= p_prev, "group 5 requires p_i to be monotonic but p_%d > p_%d", i, i + 1);
        }
        p_prev = p;
        p_all.insert(p);
        
        if (i == 0) {
            h_1 = h;
        } else if (__g == 6 || __g == 7) {
            ensuref(h == h_1, "groups 6 and 7 require all h_i to be equal but h_%d != h_1", i + 1);
        }
    }
    if (__g == 6) {
        ensuref(p_all.size() <= 2, "group 6 requires no more than two different p_i but there are %zu", p_all.size());
    }

    fori(q) {
        int qq = inf.readInt(1, T, format("t_%d", i + 1));
        inf.readEoln();
    }
    inf.readEof();
    
}