#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <random>
#include <cstring>
#include <numeric>
#include <queue>
#include <cassert>
#include <fstream>
#include <sstream>
#include <bitset>
#include <deque>
#include <complex>
#include <iterator>
#include <stack>

using namespace std;

#define M_PI 3.14159265358979323846264338327950288419716939937510
#define inf 1e18
#define eps 1e-10
#define fori(n)for (long long i = 0; i < (n); i++)
#define forj(n)for (long long j = 0; j < (n); j++)
#define rep(i, n)for (long long i = 0; i < (n); i++)
#define re return
#define ll long long
#define ull unsigned long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define bit(i, n) (((n) >> (i)) & 1)
#define ld long double
#define vec vector
#define unq(x) x.resize(unique(all(x)) - x.begin())

int __not_lg(ll n) { int cnt = 0; while (n /= 2) cnt++; re cnt; }
int __popcnt(ll n) { int ans = 0; while (n) {ans += n % 2; n >>= 1;} re ans; }

#ifdef LOCAL_BOBER
#define __lg(n) __not_lg(n)
#define __builtin_popcountll(n) __popcnt(n)
#define ffast_io ios::sync_with_stdio(false);\
                 cout.tie(nullptr)
#else
#define ffast_io ios::sync_with_stdio(false);\
                 cout.tie(nullptr); cin.tie(nullptr)
#endif

template<class T> T fast_pow(T n, ll p) { if (p == 0) re (T)1; if (p % 2) re n* fast_pow(n, p - 1); re fast_pow(n * n, p / 2); }
template<class T> T mod_fast_pow(T n, T p, T m) { if (p == 0) re(T)1; if (p % 2 == 1) re n* mod_fast_pow(n, p - 1, m) % m; re mod_fast_pow(n * n % m, p / 2, m); }
template<class T> T gcd(T a, T b) { if (!a)re b; re gcd(b % a, a); }
template<class T> void umax(T& a, T b) { a = max(a, b); }
template<class T> void umin(T& a, T b) { a = min(a, b); }
template<class T, class U> istream& operator >> (istream& o, pair<T, U>& x) { o >> x.first >> x.second; re o; }
template<class T> istream& operator >> (istream& o, pair<T, T>& x) { o >> x.first >> x.second; re o; }
template<class T> istream& operator >> (istream& o, vector<T>& x) { for (auto& el : x) o >> el; re o; }
template<class T, class U> pair<T, U> operator-(pair<T, U> a, pair<T, U> b) { return { a.first - b.first, a.second - b.second }; }
template<class T, class U> pair<T, U> operator+(pair<T, U> a, pair<T, U> b) { return { a.first + b.first, a.second + b.second }; }
template<class T> vector<T> operator+(vector<T> a, vector<T> b) { fori(a.size())a[i] += b[i]; re a; }
template<class T> vector<T> operator-(vector<T> a, vector<T> b) { fori(a.size())a[i] -= b[i]; re a; }
template<class T> string to_bin(T n) { string s = ""; while (n) { s = to_string(n % 2) + s; n >>= 1; } re s; }
template<class T> string fixed_to_bin(T n, ll q) { string s = "";  fori(q) { s = to_string(n % 2) + s; n >>= 1; } re s; }
ll from_bin(string s) { ll m = 0; fori(s.size()) { m = (m * 2) + s[i] - '0'; } re m; }
template<class T> int cnt_bit(T n) { int cnt = 0; while (n) { cnt += n % 2; n >>= 1; }re cnt; }
struct dsu {
    vector<int> v, cnt;
    void build(int n) { v.resize(n); cnt.resize(n); iota(all(v), 0); fill(all(cnt), 1); }
    dsu() {}
    dsu(int n) { build(n); }
    int get_par(int i) { if (v[i] != i)v[i] = get_par(v[i]); re v[i]; }
    bool check(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); re i1 == i2; }
    void merge(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); if (i1 == i2)re; if (cnt[i1] > cnt[i2])swap(i1, i2); cnt[i1] += cnt[i2]; v[i2] = i1; }
};

using comp = complex<double>;
const double PI = acos(-1);
void fft(vector<comp> &a, vector<comp> &r, ll n, comp x, ll ab, ll astep, ll rb) {
    if (n == 1) {
        r[rb] = a[ab];
        return;
    }
    fft(a, r, n / 2, x * x, ab, astep * 2, rb);
    fft(a, r, n / 2, x * x, ab + astep, astep * 2, rb + n / 2);
    comp w = 1;
    for (ll i = rb; i < rb + n / 2; i++) {
        comp c = r[i], d = r[i + n / 2];
        r[i] = c + d * w;
        r[i + n / 2] = c - d * w;
        w *= x;
    }
}
vector<ll> fft_mult(vector<ll> &A, vector<ll> &B) {
    vector<comp> a(A.begin(), A.end()), b(B.begin(), B.end());
    ll n = a.size() + b.size();
    while (__builtin_popcount(n) != 1) { n++; }
    while (a.size() != n) a.push_back(0);
    while (b.size() != n) b.push_back(0);
    vector<comp> ra(n), rb(n);
    comp x = comp(cos(2 * PI / n), sin(2 * PI / n));
    fft(a, ra, n, x, 0, 1, 0);
    fft(b, rb, n, x, 0, 1, 0);
    vector<comp> rab(n);
    for (ll i = 0; i < n; i++) rab[i] = ra[i] * rb[i] / comp(n);
    x = comp(cos(2 * PI / n), -sin(2 * PI / n));
    vector<comp> c(n);
    fft(rab, c, n, x, 0, 1, 0);
    vector<ll> cc(n);
    for (ll i = 0; i < n; i++)cc[i] = round(c[i].real());
    return cc;
}
/*
    ___        __              __   ______          __        _____ __             __          __  __
   /   | _____/ /___  ______ _/ /  / ____/___  ____/ /__     / ___// /_____ ______/ /______   / / / /__  ________
  / /| |/ ___/ __/ / / / __ `/ /  / /   / __ \/ __  / _ \    \__ \/ __/ __ `/ ___/ __/ ___/  / /_/ / _ \/ ___/ _ \
 / ___ / /__/ /_/ /_/ / /_/ / /  / /___/ /_/ / /_/ /  __/   ___/ / /_/ /_/ / /  / /_(__  )  / __  /  __/ /  /  __/
/_/  |_\___/\__/\__,_/\__,_/_/   \____/\____/\__,_/\___/   /____/\__/\__,_/_/   \__/____/  /_/ /_/\___/_/   \___/

*///coating_len

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,tune=native")

pair<ll, ll> cnt(vec<pair<ll, ll>>& v, ll mask) {
    ll hh = 0, ph = 0;
    fori(v.size()) {
        if (bit(i, mask)) {
            hh += v[i].second;
            ph += v[i].first * v[i].second;
        }
    }

    re {hh, ph};
}

signed main() {
    ffast_io;

    cout << fixed;
    cout.precision(10);

    int n, q; cin >> n >> q;
    vec<pair<ll, ll>> v(n);
    cin >> v;

    ll hh = 0, ph = 0;
    ll mx_p = 0, mn_p = 1e9;
    fori(n) {
        hh += v[i].second;
        ph += v[i].first * v[i].second;

        umax(mx_p, v[i].first);
        umin(mn_p, v[i].first);
    }

    reverse(all(v));

    fori(q) {
        ll x; cin >> x;

        if (x < mn_p || x > mx_p) {
            cout << "-1\n";
            continue;
        }

        ll ans = -1;
        forj(1ll << n) {
            ll a, b;
            tie(a, b) = cnt(v, j);

            ll th = ph - b;
            ll tp = hh - a;

            if ((ld)ph / (ld)hh <= x && x <= (ld)th / (ld)tp || (ld)th / (ld)tp <= x && x <= (ld)ph / (ld)hh) {
                ans = 0;
                rep(aaa, n) {
                    if (bit(aaa, j)) {
                        ans = aaa + 1;
                    }
                }
                break;
            }
        }

        cout << ans << "\n";
    }
}











