#include "testlib.h"

using namespace std;

int n, q;
vector<int> a;
vector<pair<int, int>> queries;

int const A = 1000'000'000;

vector<int> check(InStream &in) {
    vector<int> result;
    for (int t = 0; t < q; t++) {
        auto const &[l, r] = queries[t];
        int k = in.readInt(1, n + 1, format("k_%d", t + 1));

        vector<int> res, stk, actions = in.readInts(k, -1, A, format("actions_%d", t + 1));
        for (int i = 0; i < k; i++) {
            int act = actions[i];
            if (act > 0) stk.push_back(act);
            else if (act < 0) {
                in.ensuref(!stk.empty(), "attempt to pop from an empty stack on query %d action %d", t + 1, i + 1);
                stk.pop_back();
            } else {
                for (int item : stk) res.push_back(item);
            }
        }

        in.ensuref(res.size() == r - l, "resulting array has a different length on query %d", t + 1);
        for (int i = 0; i < r - l; i++) {
            in.ensuref(res[i] == a[l + i],
                       "resulting array differs from required on query %d, position %d", t + 1, i + 1);
        }

        result.push_back(k);
    }
    return result;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    n = inf.readInt(), q = inf.readInt();
    int pts = inf.readInt(), gamma = inf.readInt();
    a = inf.readInts(n);
    for (int i = 0; i < q; i++) {
        int l = inf.readInt() - 1, r = inf.readInt();
        queries.emplace_back(l, r);
    }

    auto ja = check(ans), pa = check(ouf);
    int score = pts;
    for (int i = 0; i < q; i++) {
        if (pa[i] < ja[i]) {
            if (gamma > 1) continue;
             quitf(_fail, "participant has a better answer on query %d in 'exact answer' group", i + 1);
        }
        score = min(score, pts - (pa[i] - ja[i] + gamma - 1) / gamma);
    }

    quitp(max(score, 0));

}