#include "testlib.h"

using namespace std;

#define default(type, name, value) has_opt(name) ? opt<type>(name) : value
#define all(c) c.begin(), c.end()

int main(int argc, char *argv[]) {

    int const N = 2000;
    int const Q = 10'000;
    int const A = 1000'000'000;

    registerGen(argc, argv, 1);
    int n = default(int, "n", N), q = default(int, "q", Q);
    int max_a = default(int, "max_a", A);
    int inc = default(int, "inc", 0), max_inc = default(int, "max_inc", A), w_inc = default(int, "w_inc", 0);
    int l_len = default(int, "l_len", 1), h_len = default(int, "h_len", n);

    int pts = opt<int>("pts"), gamma = default(int, "gamma", 1);

    vector<int> a(n);
    for (int &ai : a) ai = rnd.next(1, max_a);
    for (int i = 0; i < inc; i++) {
        a[rnd.wnext(n, w_inc)] = rnd.next(max_a + 1, max_inc);
    }

    println(n, q, pts, gamma);
    println(all(a));
    set<pair<int, int>> qs;
    for (int i = 0; i < q; i++) {
        int len = rnd.next(l_len, h_len);
        int l = rnd.next(1, n - len + 1);
        int t = 0;
        while (qs.count({l, l + len - 1})) {
            len = rnd.next(l_len, h_len);
            l = rnd.next(1, n - len + 1);
            if (t++ > 10) break;
        }
        println(l, l + len - 1);
        qs.insert({l, l + len - 1});
    }

}