#include <numeric>
#include "testlib.h"

using namespace std;

#define default(type, name, value) has_opt(name) ? opt<type>(name) : value
#define all(c) c.begin(), c.end()

int main(int argc, char *argv[]) {

    int const N = 2000;
    int const Q = 10'000;
    int const A = 1000'000'000;

    registerGen(argc, argv, 1);
    int n = default(int, "n", N), q = default(int, "q", Q);
    int max_a = default(int, "max_a", A);
    int l_len = default(int, "l_len", 1), h_len = default(int, "h_len", n);

    int pts = opt<int>("pts"), gamma = default(int, "gamma", 1);
    int block = default(int, "block", 50), delta = default(int, "delta", 5);

    int cnt = n / block, prev = 0, cur = 0, skip = 0;
    int total_skip = 0;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        if (i == cur + block + skip) {
            prev = cur;
            cur = i;
            skip = rnd.next(-delta, delta);
            while (abs(total_skip + skip) > 2.5 * delta) {
                skip = rnd.next(-delta, delta);
            }
            total_skip += skip;
        }
        a[i] = i < block ? rnd.next(1, max_a) : a[prev + i - cur];
    }

    println(n, q, pts, gamma);
    println(all(a));
    set<pair<int, int>> qs;
    for (int i = 0; i < q; i++) {
        int len = rnd.next(l_len, h_len);
        int l = rnd.next(1, n - len + 1);
        int t = 0;
        while (qs.count({l, l + len - 1})) {
            len = rnd.next(l_len, h_len);
            l = rnd.next(1, n - len + 1);
            if (t++ > 10) break;
        }
        println(l, l + len - 1);
        qs.insert({l, l + len - 1});
    }

}