#include "testlib.h"

using namespace std;

#define all(c) c.begin(), c.end()

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const N = 2000;
    int const Q = 10'000;
    int const A = 1000'000'000;

    // @formatter:off
    //                   0   1   2    3  4    5  6  7  8  9    10    11
    vector<int> const Ng{N, 10, 10, 200, N, 200, N, N, N, N,    N,    N};
    vector<int> const Qg{Q,  Q,  Q,   1, 1,   Q, Q, Q, Q, Q, 4000, 4000};
    vector<int> const Ag{A,  A,  A,   A, A,   A, 1, 1, 2, 2,    A,    A};
    // @formatter:on

    int __g = validator.group().empty() ? 0 : stoi(validator.group());

    int n = inf.readInt(1, Ng[__g], "n");
    inf.readSpace();
    int q = inf.readInt(1, Qg[__g], "q");
    inf.readSpace();
    inf.readInt(0, 100, "pts");
    inf.readSpace();
    inf.readInt(1, 2000, "gamma");
    inf.readEoln();

    auto a = inf.readInts(n, 1, Ag[__g], "a");
    inf.readEoln();
    if (__g == 8 || __g == 9) {
        ensuref(count(all(a), 2) <= 1, "groups 8 and 9 require no more than one '2' in a but more found");
    }

    for (int i = 0; i < q; i++) {
        int l = inf.readInt(1, n, format("l_%d", i + 1));
        inf.readSpace();
        int r = inf.readInt(1, n, format("r_%d", i + 1));
        inf.readEoln();
        ensuref(l <= r, "left border is %d and is greater than the right one %d on query %d", l, r, i + 1);
    }

    inf.readEof();

}