/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, q, pts, gamma)
    vector<int> a(n);
    cin >> a;
    int pos = max_element(all(a)) - a.begin();

    for (int t = 0; t < q; t++) {
        in(int, l, r)
        l--;
        int len = r - l;

        vector<int> actions;
        if (l > pos || r <= pos) {
            int answer = len + 1, mx = 1;
            for (int i = 1; i <= len; i++) {
                int result = i + (len + i - 1) / i;
                if (answer > result) {
                    answer = result;
                    mx = i;
                }
            }

            int rem = len % mx;
            for (int i = 0; i < mx; i++) {
                actions.push_back(1);
                if (actions.size() == rem) {
                    actions.push_back(0);
                    len -= rem;
                }
            }
            while (len > 0) {
                actions.push_back(0);
                len -= mx;
            }
        } else {
            int left = pos - l, right = r - pos - 1;
            int ans_l = left + 1, mx_l = 1;
            for (int i = 1; i <= left; i++) {
                int res_l = i + (left + i - 1) / i + (left % i > 0);
                if (ans_l >= res_l) {
                    ans_l = res_l;
                    mx_l = i;
                }
            }

            if (left > 0) {
                int rem_l = left % mx_l;
                for (int i = 0; i < mx_l; i++) {
                    actions.push_back(1);
                    if (actions.size() == rem_l) {
                        actions.push_back(0);
                        left -= rem_l;
                    }
                }
                while (left > 0) {
                    actions.push_back(0);
                    left -= mx_l;
                }
                actions.pop_back();
            } else {
                mx_l = 0;
            }
            actions.push_back(2);
            actions.push_back(0);
            actions.push_back(-1);

            if (right > 0) {
                int result = right + 2, mx = -1;
                for (int j = 1; j <= right; j++) {
                    if (j <= mx_l) {
                        if ((right + mx_l - 1) / mx_l * j > right) continue;
                        int ans_r = mx_l - j + (right + mx_l - 1) / mx_l;
                        if (result > ans_r) {
                            result = ans_r;
                            mx = j;
                        }
                    } else {
                        if ((right + j - 1) / j * mx_l > right) continue;
                        int ans_r = j - mx_l + (right + j - 1) / j;
                        if (result > ans_r) {
                            result = ans_r;
                            mx = j;
                        }
                    }
                }

                if (mx < mx_l) {
                    int cnt_r = (right + mx_l - 1) / mx_l;
                    right -= cnt_r * mx;
                    int delta = mx_l - mx;
                    for (int j = 0; j < cnt_r; j++) {
                        while (right < delta) {
                            actions.push_back(-1);
                            delta--;
                        }
                        actions.push_back(0);
                        right -= delta;
                    }
                } else {
                    int cnt_r = (right + mx - 1) / mx;
                    right -= cnt_r * mx_l;
                    int add = 0;
                    for (int j = 0; j < cnt_r; j++) {
                        int rem = cnt_r - j;
                        while (rem * (add + 1) <= right) {
                            actions.push_back(1);
                            add++;
                        }
                        actions.push_back(0);
                        right -= add;
                    }
                }
            }
        }

        cout << actions.size() << '\n';
        for (int item : actions) {
            cout << item << ' ';
        }
        cout << '\n';
    }

}