/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, q, pts, gamma)
    vector<int> a(n);
    cin >> a;

    vector<vector<int>> lcp(n + 1, vector<int>(n + 1, 0));
    for (int i = n - 1; i > -1; i--) {
        for (int j = n - 1; j > -1; j--) {
            lcp[i][j] = a[i] == a[j] ? lcp[i + 1][j + 1] + 1 : 0;
        }
    }

    for (int t = 0; t < q; t++) {
        in(int, l, r)
        l--;
        int len = r - l;

        vector<vector<int>> dp(len + 1, vector<int>(len + 1, len + 1));
        vector<vector<int>> back(len + 1, vector<int>(len + 1, -1));
        for (int i = 0; i <= len; i++) {
            dp[0][i] = i + 1;
            back[0][i] = 0;
        }
        for (int i = 0; i <= len; i++) {
            for (int prv = 0; prv < i; prv++) {
                int common = min({i - prv, len - i, lcp[l + prv][l + i]});
                int result = dp[prv][i] + (i - prv - common) + 1;
                if (dp[i][i + common] > result) {
                    dp[i][i + common] = result;
                    back[i][i + common] = prv;
                }
            }
            for (int nxt = i; nxt < len; nxt++) {
                if (dp[i][nxt + 1] > dp[i][nxt] + 1) {
                    dp[i][nxt + 1] = dp[i][nxt] + 1;
                    back[i][nxt + 1] = back[i][nxt];
                }
            }
            for (int nxt = len; nxt > i; nxt--) {
                if (dp[i][nxt - 1] > dp[i][nxt] + 1) {
                    dp[i][nxt - 1] = dp[i][nxt] + 1;
                    back[i][nxt - 1] = back[i][nxt];
                }
            }
        }

        int answer = len + 1;
        int prv = 0;
        for (int i = 1; i < len; i++) {
            if (answer > dp[i][len]) {
                answer = dp[i][len];
                prv = i;
            }
        }

        int cur = len;
        vector<int> segments{cur, prv};
        while (prv != 0) {
            int tmp = prv;
            prv = back[prv][cur];
            cur = tmp;
            segments.push_back(prv);
        }

        reverse(all(segments));
        cout << answer << '\n';
        vector<int> stk;
        for (int i = 1; i < segments.size(); i++) {
            prv = segments[i - 1];
            cur = segments[i];
            while (stk.size() > cur - prv || i > 1 && stk.size() > lcp[l + prv][l + segments[i - 2]]) {
                cout << "-1 ";
                stk.pop_back();
            }
            while (stk.size() < cur - prv) {
                int item = a[l + prv + stk.size()];
                cout << item << ' ';
                stk.push_back(item);
            }
            cout << "0 ";
        }
        cout << '\n';
    }

}