/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, q, pts, gamma)
    vector<int> a(n);
    cin >> a;

    vector<vector<int>> lcp(n + 1, vector<int>(n + 1, 0));
    for (int i = n - 1; i > -1; i--) {
        for (int j = n - 1; j > -1; j--) {
            lcp[i][j] = a[i] == a[j] ? lcp[i + 1][j + 1] + 1 : 0;
        }
    }

    vector<vector<int>> zf(n);
    for (int start = 0; start < n; start++) {
        auto &z = zf[start];
        z.resize(n - start);
        int l = 0, r = 0;
        for (int i = 1; i < z.size(); i++) {
            z[i] = max(0, min(r - i, z[i - l]));
            while (i + z[i] < z.size() && a[start + i + z[i]] == a[start + z[i]]) z[i]++;
            if (i + z[i] > r) {
                l = i;
                r = i + z[i];
            }
        }
    }

    int const BUBEN1 = min(30, static_cast<int>(sqrt(n)));
    double const BUBEN2 = 0.2;

    for (int i = 0; i < q; i++) {
        in(int, l, r)
        l--;

        vector<int> segments{l};
        int left = l;
        while (left < r) {
            auto const &z = zf[left];
            int nxt = left + 1;
            while (nxt < r) {
                if (z[nxt - left] > BUBEN1 && (nxt - left) <= z[nxt - left] * (1 + BUBEN2)) {
                    break;
                }
                nxt++;
            }
            segments.push_back(nxt);
            left = nxt;
        }

        vector<int> actions, stk;
        for (int j = 1; j < segments.size(); j++) {
            int prv = segments[j - 1], cur = segments[j];
            while (stk.size() > cur - prv || j > 1 && stk.size() > lcp[prv][segments[j - 2]]) {
                actions.push_back(-1);
                stk.pop_back();
            }
            while (stk.size() < cur - prv) {
                int item = a[prv + stk.size()];
                actions.push_back(item);
                stk.push_back(item);
            }
            actions.push_back(0);
        }

        if (actions.size() > r - l + 1) {
            actions.clear();
            for (int j = l; j < r; j++) {
                actions.push_back(a[j]);
            }
            actions.push_back(0);
        }

        cout << actions.size() << '\n';
        for (int item : actions) {
            cout << item << ' ';
        }
        cout << '\n';
    }

}