/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

vector<int> greedy(int k, int len) {
    vector<int> actions;
    for (int i = 0; i < k; i++) {
        actions.push_back(1);
    }
    int t = 0;
    while (t + k <= len) {
        actions.push_back(0);
        t += k;
    }
    int rem = len - t;
    if (rem > 0) {
        while (rem < k) {
            actions.push_back(-1);
            k--;
        }
        actions.push_back(0);
    }
    return actions;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, q, pts, gamma)
    vector<int> a(n);
    cin >> a;

    for (int i = 0; i < q; i++) {
        in(int, l, r)
        l--;
        int len = r - l;

        int t1 = 0, t2 = 0;
        while ((t1 + 1) * (t1 + 1) <= len) t1++;
        while (t2 * t2 < len) t2++;

        auto res1 = greedy(t1, len);
        auto res2 = greedy(t2, len);
        if (res1.size() > res2.size()) swap(res1, res2);
        cout << res1.size() << '\n';
        for (int item : res1) cout << item << ' ';
        cout << '\n';
    }

}